<?php
/**
* @version		1.5.1
* @package		DJ Tab Generator
* @subpackage	DJ Tab Generator Component
* @copyright	Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.
* @license		http://www.gnu.org/licenses GNU/GPL
* @autor url    http://design-joomla.eu
* @autor email  contact@design-joomla.eu
* @Developer    Lukasz Ciastek - lukasz.ciastek@design-joomla.eu
* 				Szymon Woronowski - szymon.woronowski@design-joomla.eu
* 
* 
*DJ Tab Generator is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* DJ Tab Generator is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with DJ Tab Generator. If not, see <http://www.gnu.org/licenses/>.
* 
*/
defined ('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.model');

class TabgenModelEditelement extends JModel
{
	var $_el = null;
	var $_sections = null;
	var $_categories = null;
	var $_articles = null;
	
	function getSections()
	{
		if(!$this->_sections)
		{
			$query = "SELECT id, title FROM #__sections";
			$this->_sections = $this->_getList($query, 0, 0);
		}
		$count = count($this->_sections);
		$this->_sections[$count]->id = 0;
		$this->_sections[$count]->title = JText::_('UNCATEGORIZED');

		$options = Array();	
		
		for($i=0;$i<count($this->_sections);$i++)
		{
			$options[] = Array('value' => $this->_sections[$i]->id , 'text' => $this->_sections[$i]->title);
		}
		return $options;
	}	
	
	function getCategories()
	{
		if(!$this->_categories)
		{
			$query = "SELECT c.id, c.title, s.title as section FROM #__categories c, #__sections s WHERE c.section=s.id ORDER BY section, c.title";
			$this->_categories = $this->_getList($query, 0, 0);
		}
		$options = Array();	
		
		for($i=0;$i<count($this->_categories);$i++)
		{
			$options[] = Array('value' => $this->_categories[$i]->id , 'text' => $this->_categories[$i]->section .' / '. $this->_categories[$i]->title);
		}
		return $options;
	}
	
	function getArticles (){
	  if(true){ //(!$this->_articles) {
		$elem = $this->getElement();
		$doc =& JFactory::getDocument();
		$article =& JTable::getInstance('content');
		if ($elem->type_id) {
			$article->load($elem->type_id);
		} else {
			$article->title = JText::_('Select an Article');
		}

		$js = "
		function jSelectArticle(id, title, object) {
			document.getElementById(object + '_id').value = id;
			document.getElementById(object + '_name').value = title;
			document.getElementById('sbox-window').close();
		}";
		$doc->addScriptDeclaration($js);
		$name = 'id';
		$link = 'index.php?option=com_content&amp;task=element&amp;tmpl=component&amp;object='.$name;

		JHTML::_('behavior.modal', 'a.modal');
		$html = '<div style="float: left;"><input style="background: #ffffff;" type="text" id="'.$name.'_name" value="'.htmlspecialchars($article->title, ENT_QUOTES, 'UTF-8').'" disabled="disabled" /></div>';
		$html .= '<div class="button2-left"><div class="blank"><a class="modal" title="'.JText::_('Select an Article').'"  href="'.$link.'" rel="{handler: \'iframe\', size: {x: 650, y: 375}}">'.JText::_('Select').'</a></div></div>';
		$html .= '<input type="hidden" id="'.$name.'_id" name="article" value="'.(int)($elem->type_id).'" />';
	  	$this->_articles = $html;
	  }
		return $this->_articles;
	}
	
	function getElement()
	{
		if(!$this->_el)
		{
			$cid = JRequest::getVar('cid', array(0), '', 'array' );
			$id = $cid[0];
			$query = "SELECT * FROM #__tg_elements WHERE element_id='$id'";
			$this->_el = $this->_getList($query, 0 , 0);
		}
		return $this->_el[0];
	}
}